<script setup lang="ts">
import type { WorkflowOut, WorkflowVersionOut } from "@/client/types.gen";
import FontAwesomeIcon from "@/components/FontAwesomeIcon.vue";
import dayjs from "dayjs";
import { onMounted, computed } from "vue";
import { Tooltip } from "bootstrap";
import { latestVersion as calculateLatestVersion } from "@/utils/Workflow";

const props = defineProps<{
  workflow: WorkflowOut;
  loading: boolean;
}>();

const randomIDSuffix: string = Math.random().toString(16).substring(2, 8);
const latestVersion = computed<WorkflowVersionOut | undefined>(() =>
  calculateLatestVersion(props.workflow.versions),
);

onMounted(() => {
  if (!props.loading) {
    new Tooltip("#creationDate-" + randomIDSuffix);
  }
});
</script>

<template>
  <div class="card-hover border border-secondary card m-2">
    <div class="card-body">
      <div
        class="card-title fs-3 d-flex justify-content-between align-items-center"
      >
        <div v-if="props.loading" class="placeholder-glow">
          <span class="placeholder col-6"></span>
        </div>
        <router-link
          v-else
          class="text-truncate"
          :to="{
            name: 'workflow-version',
            params: {
              workflowId: workflow.workflow_id,
              versionId: latestVersion?.workflow_version_id,
            },
            query: {
              workflowModeId: latestVersion?.modes?.[0] ?? undefined,
            },
          }"
          >{{ props.workflow.name }}
        </router-link>

        <img
          v-if="latestVersion?.icon_url != null"
          :src="latestVersion.icon_url"
          class="img-fluid float-end icon"
        />
      </div>
      <p class="card-text">
        <span v-if="props.loading" class="placeholder-glow"
          ><span class="placeholder col-12"></span
        ></span>
        <span v-else>{{ props.workflow.short_description }}</span>
      </p>
      <div class="d-flex justify-content-between mb-0">
        <div v-if="props.loading" class="placeholder-glow w-50">
          <span class="placeholder placeholder-lg w-50 bg-success"></span>
        </div>
        <router-link
          v-else
          :to="{
            name: 'workflow-version',
            params: {
              workflowId: workflow.workflow_id,
              versionId: latestVersion?.workflow_version_id,
            },
            query: {
              workflowModeId: latestVersion?.modes?.[0] ?? undefined,
            },
          }"
          class="btn btn-outline-success"
          role="button"
        >
          <font-awesome-icon class="fs-5" icon="fa-solid fa-tag" />
          {{ latestVersion?.version }}
        </router-link>
        <div v-if="props.loading" class="placeholder-glow w-25">
          <span class="placeholder w-100 bg-secondary"></span>
        </div>
        <span
          v-else-if="latestVersion"
          :id="'creationDate-' + randomIDSuffix"
          data-bs-toggle="tooltip"
          class="align-self-end text-secondary"
          :data-bs-title="
            dayjs
              .unix(latestVersion?.created_at)
              .format('MMM DD, YYYY HH:mm:ss')
          "
        >
          Last Update: {{ dayjs.unix(latestVersion?.created_at).fromNow() }}
        </span>
      </div>
    </div>
  </div>
</template>

<style scoped>
.card-hover {
  transition: transform 0.3s ease-out;
}

@media (min-width: 837px) {
  .card-hover {
    transition: transform 0.3s ease-out;
    width: 48%;
  }
}

.card-hover:hover {
  transform: translate(0, -5px);
  box-shadow: var(--bs-box-shadow) !important;
}

.icon {
  max-height: 32px;
  max-width: 32px;
}
</style>
